var isIOS = /(iPad|iPhone|iPod)/.test(navigator.userAgent);
var isAndroid = /(android)/i.test(navigator.userAgent);
var android = {
    leaderboards: {
        totalScore: 'CgkIvfGH8cYCEAIQBg',
        scoreMode0: 'CgkIvfGH8cYCEAIQBw',
        scoreMode1: 'CgkIvfGH8cYCEAIQCA',
        scoreMode2: 'CgkIvfGH8cYCEAIQCQ',
        scoreMode3: 'CgkIvfGH8cYCEAIQCg'
    }
};

var g = {
    difficulty : 'Easy',
    source : 'Tanakh / Old Testament',
    fullText: null,
    instructionsShown: false,
    frequencyIndicators : false,
    hardMaxQuoteLength : 500,
    hardMinQuoteLength : 300,
    loaded : false,
    maxQuoteLength : 700,
    minQuoteLength : 500,
    moveButtons : false,
    originalText : "",
    currentText : "",
    regroup: false,
    replacements : 20,
    sound : true,
    letters : ['A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z'],
    currentOrder : ['A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z'],
    solutionOrder : ['A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z'],
    currentFrequencies : [],
    expectedFrequencies : [8.2, 1.5, 2.8, 4.2, 12.7, 2.2, 2.0, 6.1, 7.0, 0.1, 0.8, 4.0, 2.4, 6.7, 7.5, 1.9, 0.1, 6.0, 6.3, 9.1, 2.8, 1.0, 2.4, 0.1, 2.0, 0.1],
    swapHistory : [],
    clock : null,
    clockStopped : true,
    tickInterval : null,
    highScores : [0,0,0,0],
    freeVersion : true,
    //freeVersion : false,
    //testingPaid: true,
    admobIdIOS : "ca-app-pub-9949206337857379/4141452121",
    admobIdAndroid : "ca-app-pub-9949206337857379/4560254520",
    publisherId : "pub-9949206337857379",
    sounds: {
        MUTE: 'muteSound',
        CLAP: 'clapSound',
        CLICK: 'clickSound',
        TICK: 'tickSound',
        DRAG: 'dragSound',
        CLACK: 'clackSound',
        SWAP: 'swapSound'
    },
    storePromise: jQuery.Deferred(),
    storeStates: {
        PENDING: 'pending',
        READY: 'ready',
        OFFLINE: 'offline'
    },
    hintsAvailable : 5,
    secondsUsed: 0,
    hintsUsed: 0,
    gameCenterAuth: false,
    idleTime: 0,
    MAX_IDLE_SECS: 10,
    initializing : true
};

g.storeState = g.storeStates.PENDING;

var defaultDiacriticsRemovalMap = [
    {'base':'A', 'letters':/[\u0041\u24B6\uFF21\u00C0\u00C1\u00C2\u1EA6\u1EA4\u1EAA\u1EA8\u00C3\u0100\u0102\u1EB0\u1EAE\u1EB4\u1EB2\u0226\u01E0\u00C4\u01DE\u1EA2\u00C5\u01FA\u01CD\u0200\u0202\u1EA0\u1EAC\u1EB6\u1E00\u0104\u023A\u2C6F]/g},
    {'base':'AA','letters':/[\uA732]/g},
    {'base':'AE','letters':/[\u00C6\u01FC\u01E2]/g},
    {'base':'AO','letters':/[\uA734]/g},
    {'base':'AU','letters':/[\uA736]/g},
    {'base':'AV','letters':/[\uA738\uA73A]/g},
    {'base':'AY','letters':/[\uA73C]/g},
    {'base':'B', 'letters':/[\u0042\u24B7\uFF22\u1E02\u1E04\u1E06\u0243\u0182\u0181]/g},
    {'base':'C', 'letters':/[\u0043\u24B8\uFF23\u0106\u0108\u010A\u010C\u00C7\u1E08\u0187\u023B\uA73E]/g},
    {'base':'D', 'letters':/[\u0044\u24B9\uFF24\u1E0A\u010E\u1E0C\u1E10\u1E12\u1E0E\u0110\u018B\u018A\u0189\uA779]/g},
    {'base':'DZ','letters':/[\u01F1\u01C4]/g},
    {'base':'Dz','letters':/[\u01F2\u01C5]/g},
    {'base':'E', 'letters':/[\u0045\u24BA\uFF25\u00C8\u00C9\u00CA\u1EC0\u1EBE\u1EC4\u1EC2\u1EBC\u0112\u1E14\u1E16\u0114\u0116\u00CB\u1EBA\u011A\u0204\u0206\u1EB8\u1EC6\u0228\u1E1C\u0118\u1E18\u1E1A\u0190\u018E]/g},
    {'base':'F', 'letters':/[\u0046\u24BB\uFF26\u1E1E\u0191\uA77B]/g},
    {'base':'G', 'letters':/[\u0047\u24BC\uFF27\u01F4\u011C\u1E20\u011E\u0120\u01E6\u0122\u01E4\u0193\uA7A0\uA77D\uA77E]/g},
    {'base':'H', 'letters':/[\u0048\u24BD\uFF28\u0124\u1E22\u1E26\u021E\u1E24\u1E28\u1E2A\u0126\u2C67\u2C75\uA78D]/g},
    {'base':'I', 'letters':/[\u0049\u24BE\uFF29\u00CC\u00CD\u00CE\u0128\u012A\u012C\u0130\u00CF\u1E2E\u1EC8\u01CF\u0208\u020A\u1ECA\u012E\u1E2C\u0197]/g},
    {'base':'J', 'letters':/[\u004A\u24BF\uFF2A\u0134\u0248]/g},
    {'base':'K', 'letters':/[\u004B\u24C0\uFF2B\u1E30\u01E8\u1E32\u0136\u1E34\u0198\u2C69\uA740\uA742\uA744\uA7A2]/g},
    {'base':'L', 'letters':/[\u004C\u24C1\uFF2C\u013F\u0139\u013D\u1E36\u1E38\u013B\u1E3C\u1E3A\u0141\u023D\u2C62\u2C60\uA748\uA746\uA780]/g},
    {'base':'LJ','letters':/[\u01C7]/g},
    {'base':'Lj','letters':/[\u01C8]/g},
    {'base':'M', 'letters':/[\u004D\u24C2\uFF2D\u1E3E\u1E40\u1E42\u2C6E\u019C]/g},
    {'base':'N', 'letters':/[\u004E\u24C3\uFF2E\u01F8\u0143\u00D1\u1E44\u0147\u1E46\u0145\u1E4A\u1E48\u0220\u019D\uA790\uA7A4]/g},
    {'base':'NJ','letters':/[\u01CA]/g},
    {'base':'Nj','letters':/[\u01CB]/g},
    {'base':'O', 'letters':/[\u004F\u24C4\uFF2F\u00D2\u00D3\u00D4\u1ED2\u1ED0\u1ED6\u1ED4\u00D5\u1E4C\u022C\u1E4E\u014C\u1E50\u1E52\u014E\u022E\u0230\u00D6\u022A\u1ECE\u0150\u01D1\u020C\u020E\u01A0\u1EDC\u1EDA\u1EE0\u1EDE\u1EE2\u1ECC\u1ED8\u01EA\u01EC\u00D8\u01FE\u0186\u019F\uA74A\uA74C]/g},
    {'base':'OI','letters':/[\u01A2]/g},
    {'base':'OO','letters':/[\uA74E]/g},
    {'base':'OU','letters':/[\u0222]/g},
    {'base':'P', 'letters':/[\u0050\u24C5\uFF30\u1E54\u1E56\u01A4\u2C63\uA750\uA752\uA754]/g},
    {'base':'Q', 'letters':/[\u0051\u24C6\uFF31\uA756\uA758\u024A]/g},
    {'base':'R', 'letters':/[\u0052\u24C7\uFF32\u0154\u1E58\u0158\u0210\u0212\u1E5A\u1E5C\u0156\u1E5E\u024C\u2C64\uA75A\uA7A6\uA782]/g},
    {'base':'S', 'letters':/[\u0053\u24C8\uFF33\u1E9E\u015A\u1E64\u015C\u1E60\u0160\u1E66\u1E62\u1E68\u0218\u015E\u2C7E\uA7A8\uA784]/g},
    {'base':'T', 'letters':/[\u0054\u24C9\uFF34\u1E6A\u0164\u1E6C\u021A\u0162\u1E70\u1E6E\u0166\u01AC\u01AE\u023E\uA786]/g},
    {'base':'TZ','letters':/[\uA728]/g},
    {'base':'U', 'letters':/[\u0055\u24CA\uFF35\u00D9\u00DA\u00DB\u0168\u1E78\u016A\u1E7A\u016C\u00DC\u01DB\u01D7\u01D5\u01D9\u1EE6\u016E\u0170\u01D3\u0214\u0216\u01AF\u1EEA\u1EE8\u1EEE\u1EEC\u1EF0\u1EE4\u1E72\u0172\u1E76\u1E74\u0244]/g},
    {'base':'V', 'letters':/[\u0056\u24CB\uFF36\u1E7C\u1E7E\u01B2\uA75E\u0245]/g},
    {'base':'VY','letters':/[\uA760]/g},
    {'base':'W', 'letters':/[\u0057\u24CC\uFF37\u1E80\u1E82\u0174\u1E86\u1E84\u1E88\u2C72]/g},
    {'base':'X', 'letters':/[\u0058\u24CD\uFF38\u1E8A\u1E8C]/g},
    {'base':'Y', 'letters':/[\u0059\u24CE\uFF39\u1EF2\u00DD\u0176\u1EF8\u0232\u1E8E\u0178\u1EF6\u1EF4\u01B3\u024E\u1EFE]/g},
    {'base':'Z', 'letters':/[\u005A\u24CF\uFF3A\u0179\u1E90\u017B\u017D\u1E92\u1E94\u01B5\u0224\u2C7F\u2C6B\uA762]/g},
    {'base':'a', 'letters':/[\u0061\u24D0\uFF41\u1E9A\u00E0\u00E1\u00E2\u1EA7\u1EA5\u1EAB\u1EA9\u00E3\u0101\u0103\u1EB1\u1EAF\u1EB5\u1EB3\u0227\u01E1\u00E4\u01DF\u1EA3\u00E5\u01FB\u01CE\u0201\u0203\u1EA1\u1EAD\u1EB7\u1E01\u0105\u2C65\u0250]/g},
    {'base':'aa','letters':/[\uA733]/g},
    {'base':'ae','letters':/[\u00E6\u01FD\u01E3]/g},
    {'base':'ao','letters':/[\uA735]/g},
    {'base':'au','letters':/[\uA737]/g},
    {'base':'av','letters':/[\uA739\uA73B]/g},
    {'base':'ay','letters':/[\uA73D]/g},
    {'base':'b', 'letters':/[\u0062\u24D1\uFF42\u1E03\u1E05\u1E07\u0180\u0183\u0253]/g},
    {'base':'c', 'letters':/[\u0063\u24D2\uFF43\u0107\u0109\u010B\u010D\u00E7\u1E09\u0188\u023C\uA73F\u2184]/g},
    {'base':'d', 'letters':/[\u0064\u24D3\uFF44\u1E0B\u010F\u1E0D\u1E11\u1E13\u1E0F\u0111\u018C\u0256\u0257\uA77A]/g},
    {'base':'dz','letters':/[\u01F3\u01C6]/g},
    {'base':'e', 'letters':/[\u0065\u24D4\uFF45\u00E8\u00E9\u00EA\u1EC1\u1EBF\u1EC5\u1EC3\u1EBD\u0113\u1E15\u1E17\u0115\u0117\u00EB\u1EBB\u011B\u0205\u0207\u1EB9\u1EC7\u0229\u1E1D\u0119\u1E19\u1E1B\u0247\u025B\u01DD]/g},
    {'base':'f', 'letters':/[\u0066\u24D5\uFF46\u1E1F\u0192\uA77C]/g},
    {'base':'g', 'letters':/[\u0067\u24D6\uFF47\u01F5\u011D\u1E21\u011F\u0121\u01E7\u0123\u01E5\u0260\uA7A1\u1D79\uA77F]/g},
    {'base':'h', 'letters':/[\u0068\u24D7\uFF48\u0125\u1E23\u1E27\u021F\u1E25\u1E29\u1E2B\u1E96\u0127\u2C68\u2C76\u0265]/g},
    {'base':'hv','letters':/[\u0195]/g},
    {'base':'i', 'letters':/[\u0069\u24D8\uFF49\u00EC\u00ED\u00EE\u0129\u012B\u012D\u00EF\u1E2F\u1EC9\u01D0\u0209\u020B\u1ECB\u012F\u1E2D\u0268\u0131]/g},
    {'base':'j', 'letters':/[\u006A\u24D9\uFF4A\u0135\u01F0\u0249]/g},
    {'base':'k', 'letters':/[\u006B\u24DA\uFF4B\u1E31\u01E9\u1E33\u0137\u1E35\u0199\u2C6A\uA741\uA743\uA745\uA7A3]/g},
    {'base':'l', 'letters':/[\u006C\u24DB\uFF4C\u0140\u013A\u013E\u1E37\u1E39\u013C\u1E3D\u1E3B\u017F\u0142\u019A\u026B\u2C61\uA749\uA781\uA747]/g},
    {'base':'lj','letters':/[\u01C9]/g},
    {'base':'m', 'letters':/[\u006D\u24DC\uFF4D\u1E3F\u1E41\u1E43\u0271\u026F]/g},
    {'base':'n', 'letters':/[\u006E\u24DD\uFF4E\u01F9\u0144\u00F1\u1E45\u0148\u1E47\u0146\u1E4B\u1E49\u019E\u0272\u0149\uA791\uA7A5]/g},
    {'base':'nj','letters':/[\u01CC]/g},
    {'base':'o', 'letters':/[\u006F\u24DE\uFF4F\u00F2\u00F3\u00F4\u1ED3\u1ED1\u1ED7\u1ED5\u00F5\u1E4D\u022D\u1E4F\u014D\u1E51\u1E53\u014F\u022F\u0231\u00F6\u022B\u1ECF\u0151\u01D2\u020D\u020F\u01A1\u1EDD\u1EDB\u1EE1\u1EDF\u1EE3\u1ECD\u1ED9\u01EB\u01ED\u00F8\u01FF\u0254\uA74B\uA74D\u0275]/g},
    {'base':'oi','letters':/[\u01A3]/g},
    {'base':'ou','letters':/[\u0223]/g},
    {'base':'oo','letters':/[\uA74F]/g},
    {'base':'p','letters':/[\u0070\u24DF\uFF50\u1E55\u1E57\u01A5\u1D7D\uA751\uA753\uA755]/g},
    {'base':'q','letters':/[\u0071\u24E0\uFF51\u024B\uA757\uA759]/g},
    {'base':'r','letters':/[\u0072\u24E1\uFF52\u0155\u1E59\u0159\u0211\u0213\u1E5B\u1E5D\u0157\u1E5F\u024D\u027D\uA75B\uA7A7\uA783]/g},
    {'base':'s','letters':/[\u0073\u24E2\uFF53\u00DF\u015B\u1E65\u015D\u1E61\u0161\u1E67\u1E63\u1E69\u0219\u015F\u023F\uA7A9\uA785\u1E9B]/g},
    {'base':'t','letters':/[\u0074\u24E3\uFF54\u1E6B\u1E97\u0165\u1E6D\u021B\u0163\u1E71\u1E6F\u0167\u01AD\u0288\u2C66\uA787]/g},
    {'base':'tz','letters':/[\uA729]/g},
    {'base':'u','letters':/[\u0075\u24E4\uFF55\u00F9\u00FA\u00FB\u0169\u1E79\u016B\u1E7B\u016D\u00FC\u01DC\u01D8\u01D6\u01DA\u1EE7\u016F\u0171\u01D4\u0215\u0217\u01B0\u1EEB\u1EE9\u1EEF\u1EED\u1EF1\u1EE5\u1E73\u0173\u1E77\u1E75\u0289]/g},
    {'base':'v','letters':/[\u0076\u24E5\uFF56\u1E7D\u1E7F\u028B\uA75F\u028C]/g},
    {'base':'vy','letters':/[\uA761]/g},
    {'base':'w','letters':/[\u0077\u24E6\uFF57\u1E81\u1E83\u0175\u1E87\u1E85\u1E98\u1E89\u2C73]/g},
    {'base':'x','letters':/[\u0078\u24E7\uFF58\u1E8B\u1E8D]/g},
    {'base':'y','letters':/[\u0079\u24E8\uFF59\u1EF3\u00FD\u0177\u1EF9\u0233\u1E8F\u00FF\u1EF7\u1E99\u1EF5\u01B4\u024F\u1EFF]/g},
    {'base':'z','letters':/[\u007A\u24E9\uFF5A\u017A\u1E91\u017C\u017E\u1E93\u1E95\u01B6\u0225\u0240\u2C6C\uA763]/g}
];
var changes;
var emptyFunc = function() {};
var gameOverride = {
    setUp: function (succeed, fail) {
	    cordova.exec(succeed || emptyFunc, fail || emptyFunc, "Game", "setUp", []);
    },
    login: function (succeed, fail) {
	    cordova.exec(succeed || emptyFunc, fail || emptyFunc, "Game", "login", []);
    },
    showLeaderboard: function (id, succeed, fail) {
	    cordova.exec(succeed || emptyFunc, fail || emptyFunc, "Game", "showLeaderboard", [id]);
    },
    submitScore: function (leaderboardId, score, succeed, fail) {
	    cordova.exec(succeed || emptyFunc, fail || emptyFunc, "Game", "submitScore", [leaderboardId, score]);
    }
};

function removeDiacritics (str) {
    if(!changes) {
        changes = defaultDiacriticsRemovalMap;
    }
    for(var i=0; i<changes.length; i++) {
        str = str.replace(changes[i].letters, changes[i].base);
    }
    return str;
}

function showDifficultyMenu() {
		showPopup('difficultyMenu');
		return false;
}

function inBrowser() {
    return typeof cordova == 'undefined';
}

function isFree() {
    return g.freeVersion && !inBrowser() && !g.testingPaid;
}

function changeDifficulty () {
	var newValue = $(this).data('difficulty');
    clearIdle();
	switch (newValue) {
	case 'Easy':
		g.replacements = 10;
		break;
	case 'Medium':
		g.replacements = 20;
		break;
	case 'Hard':
	    if (isFree()) {
			notFreeMessage();
			return;
		}
		g.replacements = 40;
		break;
	case 'Expert':
	default:
		if (isFree()) {
			notFreeMessage();
			return;
		}
		g.replacements = 50;
		break;
	}
	g.difficulty = newValue;
	$('#difficultyButton').html("Difficulty: " + g.difficulty);
		checkpoint();
	swal("Difficulty changed to " + g.difficulty + ". Change takes effect with next new game.");
}

function changeSource () {
	var newValue = $(this).data('source');
    clearIdle();
	if (newValue !== 'Tanakh / Old Testament' && isFree()) {
	    notFreeMessage();
	    return;
	}
	g.source = newValue;
	$('#sourceButton').html("Source: " + g.source);
		checkpoint();
	swal("Source text changed to " + g.source + ". Change takes effect with next new game.");
}

function currentStorageValue() {
		return {
				difficulty: g.difficulty,
				replacements: g.replacements,
				moveButtons: g.moveButtons,
				frequencyIndicators: g.frequencyIndicators,
				originalText: g.originalText,
				currentText: g.currentText,
				currentOrder: g.currentOrder,
				solutionOrder: g.solutionOrder,
				niceSolution: g.niceSolution,
				sound: g.sound,
				source: g.source,
				instructionsShown: g.instructionsShown,
				paidLicence: g.paidLicence,
				lastNewGameDate: g.lastNewGameDate,
				hintsAvailable: g.hintsAvailable,
				secondsUsed: g.secondsUsed,
				swapHistory: g.swapHistory,
				hintsUsed: g.hintsUsed,
				highScores: g.highScores,
				totalScore: g.totalScore
		};
}

function useStorage(result) {
		g.difficulty = result.difficulty;
		g.replacements = result.replacements;
		g.moveButtons = result.moveButtons;
		g.frequencyIndicators = result.frequencyIndicators;
		g.originalText = result.originalText;
		g.currentText = result.currentText;
		g.currentOrder = result.currentOrder;
		g.solutionOrder = result.solutionOrder;
		g.niceSolution = result.niceSolution;
		g.sound = result.sound;
		g.source = result.source;
		g.instructionsShown = result.instructionsShown;
		g.paidLicence = result.paidLicence;
		g.lastNewGameDate = (typeof result.lastNewGameDate === 'undefined') ? 0 : result.lastNewGameDate;
		g.hintsAvailable = (typeof result.hintsAvailable === 'undefined') ? 5 : result.hintsAvailable;
		g.secondsUsed = (typeof result.secondsUsed === 'undefined') ? 0 : result.secondsUsed;
		g.hintsUsed = (typeof result.hintsUsed === 'undefined') ? 0 : result.hintsUsed;
		g.swapHistory = (typeof result.swapHistory === 'undefined') ? [] : result.swapHistory;
		g.highScores = (typeof result.highScores === 'undefined') ? [0,0,0,0] : result.highScores;
		g.totalScore = (typeof result.totalScore === 'undefined') ? 0 : result.totalScore;
}

function localCheckpoint(cont) {
		localStorage.setItem('storage', JSON.stringify(currentStorageValue()));
		cont && cont(null, null);
}

function chromeCheckpoint(cont) {
        chrome.storage.local.set(currentStorageValue(), function(result) {
                if (chrome.runtime.lastError) {
                        cont && cont(chrome.runtime.lastError);
                } else {
                        cont && cont(null, null);
                }
        });
}

function localRetrieve(cont) {
		var resultStr = localStorage.getItem('storage');
		var result = null;

		if (resultStr) {
				result = JSON.parse(resultStr);
				useStorage(result);
		}
		cont && cont(null, result || currentStorageValue());
}

function chromeRetrieve(cont) {
        chrome.storage.local.get(currentStorageValue(), function(result) {
                if (chrome.runtime.lastError) {
                        cont && cont(chrome.runtime.lastError);
                } else {
                        useStorage(result);
                        cont && cont(null, result);
                }
        });
}

var checkpoint = (typeof chrome !== 'undefined' && chrome.storage) ? chromeCheckpoint : localCheckpoint;
var retrieve = (typeof chrome !== 'undefined' && chrome.storage) ? chromeRetrieve : localRetrieve;

function notFreeMessage () {
	swal({
	    title: "Feature not available",
	    text: "That feature is only available in the Full version.",
	    showCancelButton: true,
	    cancelButtonText: "Never mind",
	    closeOnConfirm: true,
	    confirmButtonColor: "#FFA500",
	    confirmButtonText: "In-game Store",
	}, function() {showPopup('storeMenu');});
}

function changeMoveButtons () {
	var i, newValue;
    clearIdle();
	newValue = $(this).data('move');
	i = 0;
	g.moveButtons = newValue && true;
	showMoveButtons();
	checkpoint();
}
function displayMovedButtons() {
    clearIdle();
    if (g.moveButtons) {
	    $('.letterButtons div').each(function (i) {
		    $(this).text(g.currentOrder[i]);
		    if (g.currentOrder[i] === g.letters[i]) {
			    $(this).removeClass("moved");
		    } else {
			    $(this).addClass("moved");
		    }
	    });
    }
}
function showMoveButtons() {
    clearIdle();
	if (g.moveButtons) {
		$('body').addClass('moveButtons');
		$('#moveButtons').html("Move Buttons: On");
        displayMovedButtons();
	} else {
		$('body').removeClass('moveButtons');
		$('#moveButtons').html("Move Buttons: Off");
		$('.letterButtons div').each(function (i) {
			$(this).text(g.letters[i]);
			$(this).removeClass("moved");
		});
	}
	if (g.originalText) {
	    updateFrequencies();
	}
}

function changeFrequency () {
	var newValue = $(this).data('frequency');
    clearIdle();
	if (newValue && isFree()) {
		notFreeMessage();
		return;
	}
	g.frequencyIndicators = newValue && true;
	if (g.frequencyIndicators) {
	    $('#frequencyButton').html("&fnof;-indicators: On");
        $(document.body).addClass('showFrequencies');
	} else {
	    $('#frequencyButton').html("&fnof;-indicators: Off");
        $(document.body).removeClass('showFrequencies');
	}
	checkpoint();
}

function changeSound () {
	var newValue = $(this).data('sound');
    clearIdle();
	g.sound = newValue && true;
	if (g.sound) {
		$('#soundButton').html("Sound: On");
	} else {
		playAudio(g.sounds.MUTE);
		$('#soundButton').html("Sound: Off");
	}
	checkpoint();
}

function toggleSound () {
    clearIdle();
	g.sound = !g.sound;
	if (g.sound) {
		$('#soundButton').html("Sound: On");
		$('#muteButton').removeClass('muted');
	} else {
		$('#soundButton').html("Sound: Off");
		$('#muteButton').addClass('muted');
	}
	checkpoint();
}

function randInt (x) {
	var roll = Math.floor(Math.random() * x);
	return roll;
}

function tutorialSwap (text, letterOne, letterTwo) {
    if (!text) {
        return text;
    }
	regExp = new RegExp(letterOne, "g");
	text = text.replace(regExp, "zz");
	regExp = new RegExp(letterTwo, "g");
	text = text.replace(regExp, letterOne);
	regExp = new RegExp("zz", "g");
	text = text.replace(regExp, letterTwo);
	return text;
}

function swapLetters (text, letterOne, letterTwo, manual, lockLetters) {
	var indexOne, indexTwo, temp;
    clearIdle();
	if (!text) {
		return text;
	}
	if (letterOne !== letterTwo) {
		regExp = new RegExp(letterOne, "g");
		text = text.replace(regExp, "zz");
		regExp = new RegExp(letterTwo, "g");
		text = text.replace(regExp, letterOne);
		regExp = new RegExp("zz", "g");
		if (lockLetters) {
		    text = text.replace(regExp, "<span class='lockedletter'>" + letterTwo + "</span>");
		} else {
		    text = text.replace(regExp, letterTwo);
		}
	}
	if (manual) {
	    indexOne = g.currentOrder.indexOf(letterOne);
    	indexTwo = g.currentOrder.indexOf(letterTwo);
		g.currentOrder[indexOne] = letterTwo;
		g.currentOrder[indexTwo] = letterOne;
		g.swapHistory.push([letterOne, letterTwo]);
	}
	indexOne = g.solutionOrder.indexOf(letterOne);
    indexTwo = g.solutionOrder.indexOf(letterTwo);
    g.solutionOrder[indexOne] = letterTwo;
	g.solutionOrder[indexTwo] = letterOne;
	return text;
}

function undoSwap () {
	var poppedPair = g.swapHistory.pop();
    clearIdle();
	if (poppedPair) {
		if (g.sound) {
    		playAudio(g.sounds.CLICK);
    	}
		g.currentText = swapLetters(g.currentText, poppedPair[0], poppedPair[1], true);
		g.swapHistory.pop(); /* because swapping back added it again */
				checkpoint();
		fillQuoteBox(g.currentText);
        displayMovedButtons();
		updateFrequencies();
	}
}

String.prototype.chunk = function(n) {
	var ret = [];
	for(var i=0, len=this.length; i < len; i += n) {
	   ret.push(this.substr(i, n))
	}
	return ret
};

function bonusHint () {
    var todaysDate = new Date();
	if (typeof g.lastNewGameDate == 'undefined' || g.lastNewGameDate !== todaysDate.getDate() && g.hintsAvailable < 5) {
	    g.hintsAvailable += 1;
	    $('#hintsAvailable').text(g.hintsAvailable);
	    showPopup('extraHintOfDay');
	}
	g.lastNewGameDate = todaysDate.getDate();
}

function gotText(response, continuing) {
	var i, j, totalNumberOfParagraphs, success, letterOne, letterTwo, regExp, oneBook,
		maxQuoteLength, minQuoteLength, lockedLetters, lockedButtons;

	if (!g.difficulty || !g.replacements) {
		g.difficulty = 'Medium';
		g.replacements = 20;
	}
	if (g.difficulty === 'Easy') {
		$('#progressGauge').show();
		$('#difficultyPlaque').addClass('hideOnSmallDevices');
	} else {
	    $('#progressGauge').hide();
	    $('#difficultyPlaque').removeClass('hideOnSmallDevices');
	}
	$('#difficultyButton').html("Difficulty: " + g.difficulty);
	$('#difficultyPlaque').text(g.difficulty);
	$('.difficulty').text(g.difficulty);
	$('#sourceButton').html("Source: " + g.source);

		showMoveButtons();
	if (g.frequencyIndicators) {
		$('#frequencyButton').html("&fnof;-indicators: On");
		$(document.body).addClass('showFrequencies');
	} else {
		$('#frequencyButton').html("&fnof;-indicators: Off");
		$(document.body).removeClass('showFrequencies');
	}
	if (g.sound) {
		$('#soundButton').html("Sound: On");
		$('#muteButton').removeClass('muted');
	} else {
		$('#soundButton').html("Sound: Off");
		$('#muteButton').addClass('muted');
	}

	if (g.difficulty === 'Hard' || g.difficulty === 'Expert') {
		maxQuoteLength = g.hardMaxQuoteLength;
		minQuoteLength = g.hardMinQuoteLength;
	} else {
		maxQuoteLength = g.maxQuoteLength;
		minQuoteLength = g.minQuoteLength;
	}
    g.fullText = response;

    $('#hintsAvailable').text(g.hintsAvailable);

	if (continuing) {
        displayMovedButtons();
        if (g.secondsUsed) {
            g.clock.setTime(g.secondsUsed);
        }
        lockedLetters = $('<div>' + continuing + '</div>').find('.lockedletter').map(function(i, el) {
            return $(el).text();
        }).get();
        if (!lockedLetters) {
            lockedLetters = [];
        }
        $('#letterBox .letterButtons .letterButton').each(function (i, el) {
            if (lockedLetters.indexOf($(this).text()) !== -1) {
                $(this).addClass('locked')
                       .draggable('disable')
                       .droppable('disable');
            }
        });
	} else {
	    g.originalText = response;
	    g.books = g.originalText.split(/\<hr.*/);
	    switch (g.source) {
	      case 'Tanakh / Old Testament':
	        i = randInt(39);
	        break;
	      case 'New Testament':
	        i = randInt(26) + 39;
	        break;
	      default:
	      i = randInt(g.books.length);
	    }
	    oneBook = g.books[i];
	    g.bookName = oneBook.match(/\<h3.*/)[0];
	    g.bookName = g.bookName.replace(/<(?:.|\n)*?>/gm, '');
	    console.log("bookname is " + g.bookName);
	    oneBook = oneBook.replace(/<(?:.|\n)*?>/gm, '');
	    g.paragraphs = oneBook.split(/\r\n\r\n|\n\n/);
    	totalNumberOfParagraphs = g.paragraphs.length;
		success = false;
		while (!success) {
			i = randInt(totalNumberOfParagraphs);
			g.i = i;
			g.originalText = g.paragraphs[i];
			g.niceSolution = g.paragraphs[i];
			g.originalText = g.originalText.replace(/'/g, "");
			g.originalText = removeDiacritics(g.originalText);
			g.originalText = g.originalText.replace(/\d+:\d+/g, "");
			g.originalText = g.originalText.replace(/[^A-Za-z 0-9]/g, " ");
			g.originalText = g.originalText.trim();
			if (g.difficulty === 'Expert') {
				g.originalText = g.originalText.replace(/\s+/g, "");
				g.originalText = g.originalText.chunk(5).join(' ');
			} else {
				g.originalText = g.originalText.replace(/\s+/g, " ");
			}
			g.paras = 1;
			if (g.originalText.length > maxQuoteLength) {
				continue;
			}
			j = i + 1;
			while (g.originalText.length < minQuoteLength && j < totalNumberOfParagraphs) {
				g.niceSolution = g.niceSolution + "<br><br>" + g.paragraphs[j];
				g.originalText = g.originalText + "\n\n" + g.paragraphs[j];
				g.originalText = g.originalText.replace(/'/g, "");
				g.originalText = removeDiacritics(g.originalText);
				g.originalText = g.originalText.replace(/\d+:\d+/g, "");
				g.originalText = g.originalText.replace(/[^A-Za-z 0-9]/g, " ");
				g.originalText = g.originalText.trim();
				if (g.difficulty === 'Expert') {
					g.originalText = g.originalText.replace(/\s+/g, "");
					g.originalText = g.originalText.chunk(5).join(' ');
				} else {
					g.originalText = g.originalText.replace(/\s+/g, " ");
				}
				g.paras++;
				j++;
			}
			if (i === totalNumberOfParagraphs || g.originalText.length > maxQuoteLength || g.originalText.length < minQuoteLength) {
				continue;
			}
			g.originalText = g.originalText.toUpperCase();
			success = true;
		}
		g.niceSolution = "<center><strong>" + g.bookName + "</strong></center><br><br><br>\n" + g.niceSolution;
		console.log("nice solution is " + g.niceSolution);
		g.currentText = g.originalText;
		for (i = 0; i < g.replacements; i++) {
			letterOne = g.letters[randInt(26)];
			letterTwo = g.letters[randInt(26)];
			g.currentText = swapLetters(g.currentText, letterOne, letterTwo);
		}
				checkpoint();
	}
	fillQuoteBox(g.currentText);
	updateFrequencies();
	$("#quoteBox").show();
}

function fillQuoteBox(content) {
    $("#quoteBox").html(content);
}

function clearText() {
		g.originalText = g.currentText = g.niceSolution = null;
		g.currentOrder = g.letters.slice();
		g.solutionOrder = g.letters.slice();
		checkpoint();
}

var difficultyIndex;

function currentDifficultyIndex() {
    switch (g.difficulty) {
	case "Easy":
	    difficultyIndex = 0;
	    break;
	case "Medium":
	    difficultyIndex = 1;
	    break;
	case "Hard":
	    difficultyIndex = 2;
	    break;
	case "Expert":
	default:
	    difficultyIndex = 3;
	    break;
    }
    return difficultyIndex;
}

function currentScore() {
	var score = g.replacements * 2000 - g.secondsUsed * 100 - g.swapHistory.length * 100 - g.hintsUsed - 1000;

	return score < 1000 ? 1000 : score;
}

function win() {
    var i, score, highScore, scoreSubmitted, totalScoreSubmitted, popupClosed;
    clearIdle();
	stopClock();
	if (g.sound) {
		playAudio(g.sounds.CLAP);
	}
	i = randInt($('#youWin li').length);

    score = currentScore();
	g.totalScore += score;
    difficultyIndex = currentDifficultyIndex();
    highScore = g.highScores[difficultyIndex];

    if (score > highScore) {
        $('#regularHighScore').hide();
        $('#newHighScore').show();
        g.highScores[difficultyIndex] = score;
    } else {
        $('#regularHighScore').show();
        $('#newHighScore').hide();
    }
    checkpoint();

	$('#youWin li').hide();
	$('#youWin li:nth(' + i + ')').show();
	$('#youWin #secondsUsed').text(g.secondsUsed);
	$('#youWin #swapsMade').text(g.swapHistory.length);
	$('#youWin #hintsUsed').text(g.hintsUsed);
	$('#youWin #score').text(score);
	$('#youWin #highScore').text(highScore);

	if (g.gameCenterAuth) {
	    scoreSubmitted = jQuery.Deferred();
	    totalScoreSubmitted = jQuery.Deferred();
	    g.youWinPopupClosed = jQuery.Deferred();

	    $.when(scoreSubmitted, totalScoreSubmitted, g.youWinPopupClosed).done(function () {
            showLeaderboard(difficultyIndex);
	    });
        submitScore(scoreSubmitted, totalScoreSubmitted);
	}
	showPopup('youWin');
}

function showLeaderboard (difficultyIndex) {
	if (!g.gameCenterAuth) {
        startGameCenter(actualShowLeaderboard);
    } else {
        actualShowLeaderboard();
    }
}

function actualShowLeaderboard() {
	difficultyIndex = currentDifficultyIndex();
	console.log('difficultyIndex is ' + difficultyIndex);
    if (isIOS) {
        gamecenter.showLeaderboard(function() {}, function () {console.log("show leaderboard failed");}, {leaderboardId: 'scoreMode' + difficultyIndex});
    } else {
        gameOverride.showLeaderboard(android.leaderboards['scoreMode' + difficultyIndex], function() {}, function () {console.log("show leaderboard failed", arguments);});
    }
}

var medias = {};
var mediaFuncs = {};

function playIosAudio(id) {
    var audioElement, my_media, url;
    setTimeout (function () {

    audioElement = document.getElementById(id);
    url = audioElement.getAttribute('src');
    if (typeof Media !== 'undefined') {
        if (!medias[url]) {
            medias[url] = new Media(url,
                                    // success callback
                                    function () {
                                        //console.log("playAudio():Audio Success");
                                    },
                                    // error callback
                                    function (err) {
                                        //console.log("playAudio():Audio Error: " + err);
                                    }
                                    // Play audio
                                   );
            mediaFuncs[url] = function () {
                medias[url].play({ playAudioWhenScreenIsLocked : false });
            };
            mediaFuncs[url] = _.throttle(mediaFuncs[url], 500);
        }
        mediaFuncs[url]();
    }
    }, 1);
}

function playAndroidAudio(id) {
    document.getElementById(id).play();
}

lowLatencyPluginAudio = (function(){
    var loaded = {};

    function play(name) {
        if (loaded[name]) {
            loaded[name].then(function() {
                window.plugins.LowLatencyAudio.stop(name);
                window.plugins.LowLatencyAudio.muteStatus(function(muted) {
                    if (!muted) {
                        window.plugins.LowLatencyAudio.play(name);
                    }
                });
            });
        }
    }

    function loadSound(name) {
        if (loaded[name]) {
            return loaded[name];
        } else {
            var def = jQuery.Deferred();
            var el = document.getElementById(name);

            loaded[name] = def;
            if (!el) {
                def.reject("No element named " + name);
            } else {
                window.plugins.LowLatencyAudio.preloadFX(name, el.getAttribute('src'), function () {def.resolve();}, function(err) {def.reject(err);});
            }
        }
        return def;
    }

    function loadSounds() {
        if (!window.plugins || !window.plugins.LowLatencyAudio) {
            return jQuery.Deferred().reject();
        } else {
            var pending = [];

            for (var soundName in g.sounds) {
                var snd = loadSound(g.sounds[soundName]);

                if (isPromisey(snd)) {
                    pending.push(snd);
                }
            }
            return pending.length ? $.when.apply(null, pending) : jQuery.Deferred().resolve();
        }
    }

    return {
        init: loadSounds,
        play: play
    };
})();

function isPromisey(obj) {
    return typeof obj == 'object' && obj.then;
}

var initAudio = isIOS ? function() {return jQuery.Deferred().resolve();} : lowLatencyPluginAudio.init;

var playAudio = isIOS ? playIosAudio : lowLatencyPluginAudio.play;

function showPopup (which) {
    clearIdle();
	if (g.sound) {
		playAudio(g.sounds.CLICK);
	}
	$('#popupWrapper > div').hide();
	$('#' + which).show();
	$('#popupWrapper').show();
}

function hidePopup() {
    clearIdle();
	if ($('#youWin:visible').length) {
	    if (g.youWinPopupClosed) {
	        g.youWinPopupClosed.resolve(true);
	    }
	    fillQuoteBox(g.niceSolution);
	    $('#quoteBox')[0].scrollTop = 0;
		$('#quoteContainer').addClass('won');
		$('#letterBox').hide();
		$('#playAgain').show();
		clearText();
	}
	if (g.sound) {
		playAudio(g.sounds.CLICK);
	}
	$('#popupWrapper > div').hide();
	$('#popupWrapper').hide();
}

function getUrlParameter(sParam) {
	var sPageURL = window.location.search.substring(1);
	var sURLVariables = sPageURL.split('&');
	for (var i = 0; i < sURLVariables.length; i++) {
		var sParameterName = sURLVariables[i].split('=');
		if (sParameterName[0] == sParam) {
			return sParameterName[1];
		}
	}
}

function calculateFrequency(str, letter) {
	var i, len, tallies;
	if (!str || !letter) {
	    return 0;
	}
	len = str.length;
	tallies = (str.split(letter).length - 1);
	return (tallies / len * 100).toFixed(1);
}

function getStrippedCurrentText () {
    return $("<div>").html(g.currentText).text();
}

function updateFrequencies() {
	var i, strLength, nonSpaceCount, matchingCount, percent, strippedCurrentText;
	strippedCurrentText = getStrippedCurrentText();
	$(".letterButtons .letterButton").each(function (i) {
        var currentLetter, letterIndex;
        currentLetter = $(this).text();
        letterIndex = g.letters.indexOf(currentLetter);
        $(".currentFrequency:nth(" + i + ")").text(calculateFrequency(strippedCurrentText, currentLetter));
        $(".expectedFrequency:nth(" + i + ")").text(g.expectedFrequencies[letterIndex].toFixed(1));
	});
	if ($('#difficultyPlaque').text() === 'Easy') {
		nonSpaceCount = 0;
		matchingCount = 0;
		strLength = g.originalText.length;
		for (i = 0; i < strLength; i++) {
			if (g.originalText[i] === ' ') {
				continue;
			}
			nonSpaceCount++;
			if (g.originalText[i] === strippedCurrentText[i]) {
				matchingCount++;
			}
		}
		percent = matchingCount / nonSpaceCount * 100;
		if (!g.gauge.adjustedY) {
			g.gauge.txtTitle.attr("y", 5);
			g.gauge.adjustedY = true;
		}
		g.gauge.refresh(Math.floor(percent));
	}
}

function tick() {
	if (g.sound) {
		playAudio(g.sounds.TICK);
	}
	g.secondsUsed++;
}

function SimpleClock (span) {
    var that = this;
    this.time = 0;
    this.elem = $(span);
    this.start = function () {
        that.tickInterval = setInterval(that.tick, 1000);
    };
    this.stop = function () {
        if (that.tickInterval) {
    		clearInterval(that.tickInterval);
    		that.tickInterval = null;
    	}
    };
    this.tick = function () {
        that.time++;
        that.showTime();
    };
    this.setTime = function (t) {
        that.time = t;
        that.showTime();
    };
    this.showTime = function () {
        var s, m, h;
        s = that.time;
        h = Math.floor(that.time / 3600);
        s -= h * 3600;
        m = Math.floor(that.time / 60);
        s -= m * 60;
        if (s == 0) {
            s = "00";
        } else if (s < 10) {
            s = "0" + s;
        }
        if (m == 0) {
            m = "00";
        } else if (m < 10) {
            m = "0" + m;
        }
        if (h == 0) {
            h = "00";
        } else if (h < 10) {
            h = "0" + h;
        }

        that.elem.text(h + ':' + m + ':' + s);
    };
}

function startClock(ifPaused) {
	if (!g.clock) {
		return;
	}
	if (!g.tickInterval && (!ifPaused || g.clockPaused)) {
		g.clock.start();
		g.clockPaused = g.clockStopped = false;
		g.tickInterval = setInterval(tick, 1000);
	}
}

function stopClock(pause) {
	if (!g.clock) {
		return;
	}
	g.clock.stop();
	g.clockStopped = true;
    g.clockPaused = pause;
	if (g.tickInterval) {
		clearInterval(g.tickInterval);
		g.tickInterval = null;
	}
}

function switchToPaidVersion() {
    clearIdle();
    g.freeVersion = false;
    $("#purchaseLI").remove();
    $(".notAvailable").removeClass("notAvailable");
}

function isOwned(product) {
	return product.owned || product.approved || product.finished;
}

function initializeStore() {
    var product;
    console.log("QQQ initializeStore");
    if (typeof store != 'undefined') {
    	console.log('QQQ store exists');
        store.verbosity = store.DEBUG;
        store.register([
            {
                id:    'paid_licence',
                alias: 'Paid Licence',
                type:  store.NON_CONSUMABLE
            },
            {
                id:     'five_hints',
                alias:  'Five Hints',
                type:   store.CONSUMABLE
            },
            {
                id:     'fifteen_hints',
                alias:  'Fifteen Hints',
                type:   store.CONSUMABLE
            }
        ]);
        console.log('QQQ registered items');
        store.when("paid_licence").finished(function(p) {
            console.log("QQQ paid_licence finished");
            console.log("QQQ finished product state is " + p.state);
        });
        store.when("paid_licence").owned(function(p) {
        	console.log("QQQ paid_licence owned");
        	console.log("QQQ owned product state is " + p.state);
        });
        store.when("paid_licence").cancelled(function(p) {
            console.log("QQQ paid_licence cancelled");
           	console.log("QQQ owned product state is " + p.state);
        });
        store.when("paid_licence").refunded(function(p) {
            console.log("QQQ paid_licence refunded");
            console.log("QQQ owned product state is " + p.state);
        });
        store.when("paid_licence").approved(function(p) {
        	p.finish();
        	console.log("QQQ called p.finish");
            console.log("QQQ paid Licence approved");
            switchToPaidVersion();
            if (!g.initializing) {
            	swal({
                	title: "Success",
            		text: "Paid licence activated."
            	});
            }
        });
        store.when('five_hints').approved(function(p) {
        	p.finish();
            g.hintsAvailable += 5;
            $('#hintsAvailable').text(g.hintsAvailable);
            checkpoint();
        });
        store.when('fifteen_hints').approved(function(p) {
        	p.finish();
            g.hintsAvailable += 15;
            $('#hintsAvailable').text(g.hintsAvailable);
            checkpoint();
        });
        g.storePromise.then(function() {
            var paidLicensePrice = store.get('paid_licence').price;
            console.log("QQQ \\o/ STORE READY \\o/");
            $('#purchaseButton .price').text(' (' + paidLicensePrice + ')');
            $('#tutorialPrice').text(paidLicensePrice);
            $('#purchasePakButton .price').text(' (' + store.get('five_hints').price + ')');
            $('#purchaseBigPakButton .price').text(' (' + store.get('fifteen_hints').price + ')');
            console.log("QQQ price of paid is " + paidLicensePrice);
            product = store.get("paid_licence");
            console.log("QQQ product state is " + product.state);
            if (isOwned(product)) {
            	var paidLicenceWas = g.paidLicence;
            	console.log("QQQ product owned is true");
                g.paidLicence = true;
                switchToPaidVersion();
                if (!paidLicenceWas) {
                	checkpoint();
                }
            } else {
            	console.log("QQQ product not owned, checking for approval");
            }
            if (g.paidLicence != isOwned(product)) {
                g.paidLicence = isOwned(product);
                checkpoint();
            }
            g.initializing = false;
        });
        store.ready(function() {
            storeState = g.storeStates.READY;
            console.log("QQQ store ready, resolving promise");
            g.storePromise.resolve();
        });
        store.error(function(e) {
        	console.log("QQQ store error. Message is (" + e.message + "), resolving promise");
            storeState = g.storeStates.OFFLINE;
            g.storePromise.resolve();
        });
        console.log("QQQ calling store.refresh");
        store.refresh();
    } else {
    	console.log("QQQ store doesn't exist");
        g.storePromise.resolve();
    }
}

function purchaseFullVersion() {
    store.order("paid_licence");
}

function restorePurchases() {
    store.refresh();
}

function purchasePakButton() {
    store.order('five_hints');
}

function purchaseBigPakButton() {
    store.order('fifteen_hints');
}

function askAboutGameCenter() {
    clearIdle();
    if (isIOS) {
        swal({
            title: "Game Center",
            text: "Would you like to connect to Apple's Game Center to compete with other users?",
            showCancelButton: true,
            confirmButtonColor: "#FFA500",
            confirmButtonText: "Connect",
            closeOnConfirm: true,
            cancelButtonText: "Don't Connect"
        }, startGameCenter);
        /* swap order so Connect comes first */
        $(".sweet-alert button:nth(0)").before($(".sweet-alert button:nth(1)"));
    } else {
        startGameCenter();
    }
}

function submitScore(scoreSubmitted, totalScoreSubmitted) {
    if (isIOS) {
	    gamecenter.submitScore(
	        function () {
	            console.log("total score submitted");
	            totalScoreSubmitted.resolve(true);
	        },
	        function () {
	            console.log("submit total score failed");
	            totalScoreSubmitted.resolve(false);
	        },
	        {score: g.totalScore, leaderboardId: 'totalScore'}
	    );
	    gamecenter.submitScore(
	        function () {
	            console.log("score submitted");
                scoreSubmitted.resolve(true);
	        },
	        function () {
	            console.log("score submission failed");
	            scoreSubmitted.resolve(false);
	        },
	        {score: currentScore(), leaderboardId: 'scoreMode' + currentDifficultyIndex()}
	    );
    } else {
        gameOverride.submitScore(
            android.leaderboards["totalScore"],
            g.totalScore,
	        function () {
	            console.log("total score submitted");
	            totalScoreSubmitted.resolve(true);
	        },
	        function () {
	            console.log("submit total score failed");
	            totalScoreSubmitted.resolve(false);
            });
        gameOverride.submitScore(
            android.leaderboards["scoreMode" + currentDifficultyIndex()],
            currentScore(),
	        function () {
	            console.log("score submitted");
                scoreSubmitted.resolve(true);
	        },
	        function () {
	            console.log("score submission failed");
	            scoreSubmitted.resolve(false);
	        }
        );
    }
}

function startGameCenter(cont) {
    clearIdle();
    console.log("Starting game center...");
    if (isIOS) {
        console.log("calling gamecenter auth");
        gamecenter.auth(function (user) {
            g.gameCenterAuth = true;
            console.log("authorized user " + user.displayName + " with game center");
            cont && cont();
        },
        function () {
            g.gameCenterAuth = false;
            console.log("auth failed");
        });
    } else {
        gameOverride.setUp(function(){
            console.log("Game center setup succeeded, logging in");
            gameOverride.login(
                function (user) {
                    g.gameCenterAuth = true;
                    console.log("authorized user " + user.playerDisplayName + " with game center");
                    cont && cont();
                },
                function () {
                    g.gameCenterAuth = false;
                    console.log("game center authorization failed");
                });
        }, function() {
            console.log("Game center setup failed");
        });
    }
}
function onDeviceReady() {
    if (isAndroid) {
    	gameOverride.__proto__ = game;
    }
    clearIdle();
    console.log("onDeviceReady");
    initializeStore();
    if (!g.freeVersion) {
        switchToPaidVersion();
    }
    initAudio().always(function() {
        if (!isIOS) {
            $('body').addClass('not-ios');
            console.log("not IOS");
        }
        console.log("before get");
        $.get("data/bible.html", function (resp) { console.log("in get"); gotText(resp, g.currentText); });
        console.log("after get");
        retrieve(function() {
            init();
            if (!g.loaded) {
                var promise = (g.paidLicence ? jQuery.Deferred().resolve() : g.storePromise);

                g.loaded = true;
                promise = promise.always(function() {
                    if (isFree()) {
                        $(document).ready(function() {
                            $(".fullOnly").addClass("notAvailable");
                            initAd();
                            // display the banner at startup
                            console.log("QUEUING AD");
                            /*cacheAd(showAd);
                            afterAd.always(function() {
                                console.log("DONE SHOWING AD");
                                //navigator.splashscreen.hide();
                                $('body').removeClass('notReady');
                                askAboutGameCenter();
                            });*/
                            /* caching ad but not showing */
                            cacheAd();
                            console.log("FREE VERSION HIDING SPLASH");
                            $('body').removeClass('notReady');
                            askAboutGameCenter();
                        });
                    } else {
                        console.log("PAID VERSION HIDING SPLASH");
                        $('body').removeClass('notReady');
                        askAboutGameCenter();
                    }
                });
                if (promise == g.storePromise) {
                    g.storePromise = promise;
                }
            }
        });
    }).fail(function (err) {
        console.log("Failed to initialize audio: " + err);
    });
}

var currentAd = jQuery.Deferred();
var afterAd = jQuery.Deferred();

function showAd(err) {
    clearIdle();
    if (!err && isFree()) {
        console.log("Attempting to show ad");
        admob.showInterstitial(function() {
            console.log("Showing ad");
        }, function() {
            console.log("Not showing ad");
        });
    } else {
        afterAd.reject();
        if (isFree()) {
            console.log("Not showing ad because error receiving", err);
            cacheAd();
        } else {
            console.log("Not showing ad because paid", err);
        }
        setTimeout(bonusHint, 1000);
    }
}

function whenAd(action) {
    currentAd.then(function(result) {
        action(null, result);
    }, function(err) {
        action(err);
    });
}

function cacheAd(action) {
    if (isFree()) {
        var ad = currentAd = jQuery.Deferred();

        afterAd = jQuery.Deferred();
        if (action) {
            whenAd(action);
        }
        admob.isInterstitialReady(function(ready) {
            console.log("caching ad...");
            //admob.cacheInterstitial(null, function(e) {console.log("received ad", arguments);}, function(e) {console.log("did not receive ad", arguments);ad.reject(e);});
            admob.cacheInterstitial(null);
        });
    } else {
        if (action) {
            action("paid version");
        }
        afterAd.resolve();
    }
}

function registerAdEvents() {
    var events = [
        admob.Event.onBannerDismiss,
        admob.Event.onBannerFailedReceive,
        admob.Event.onBannerLeaveApplication,
        admob.Event.onBannerPresent,
        admob.Event.onBannerReceive,
        //admob.Event.onInterstitialReceive,
        //admob.Event.onInterstitialFailedReceive,
        //admob.Event.onInterstitialDismiss,
        admob.Event.onInterstitialLeaveApplication,
        admob.Event.onInterstitialPresent,
        admob.Event.onInterstitialReceive
    ];

    for (var i = 0; i < events.length; i++) {
        document.addEventListener(events[i], (function(i){return function(e){console.log("AD EVENT: " + events[i], e);};})(i));
    }
    document.addEventListener(admob.Event.onInterstitialReceive, function(e) {
        console.log("received ad", e);
        currentAd.resolve(e);
    });
    document.addEventListener(admob.Event.onInterstitialFailedReceive, function(e) {
        console.log("failed to receive ad", e);
        currentAd.reject(e);
    });
    document.addEventListener(admob.Event.onInterstitialDismiss, function(e) {
        console.log("dismissed ad", e);
        afterAd.resolve(e);
        cacheAd();
        bonusHint();
    });
}

function initAd(){
	if ( window.admob ) {
		if (isAndroid) {
			admobid = g.admobIdAndroid;
		} else if (/(iphone|ipad)/i.test(navigator.userAgent)) {
			admobid = g.admobIdIOS;
		}
        admob.initAdmob(null, admobid);
	    registerAdEvents();
    }
}

function indicateDrag(el, start) {
    clearIdle();
    if (start) {
	    if (g.clockStopped) {
	     startClock();
	    }
	    if (g.sound) {
	        playAudio(g.sounds.DRAG);
	    }
	    //$(el).css('z-index', 999);
	    if ($(el).hasClass("moved")) {
	        $(el).data("wasMoved", true);
	        $(el).removeClass("moved");
	    } else {
	        $(el).data("wasMoved", false);
	    }
    } else {
	    //$(el).css('z-index', '');
	    if ($(el).data("wasMoved")) {
	        $(el).addClass("moved");
        }
    }
}

function getHint() {
    var boughtLetter, doubleSwappers, singleSwappers, swapPair, strippedCurrentText;
    clearIdle();
    strippedCurrentText = getStrippedCurrentText();
    if (g.originalText === strippedCurrentText) {
        return;
    }
    if (!g.solutionOrder) {
        showPopup('newGameForHints');
        return;
    }
    if (g.hintsAvailable < 1) {
        showPopup('noMoreHints');
        return;
    }
    swapPair = null;
    doubleSwappers = [];
    singleSwappers = [];
    _.each(g.solutionOrder, function (letter, currentIndex) {
        if (strippedCurrentText.indexOf(letter) !== -1 && letter !== g.letters[currentIndex]) {
            console.log("indexOf " + g.letters[currentIndex] + " is " + strippedCurrentText.indexOf(g.letters[currentIndex]));
            if (g.solutionOrder[g.letters.indexOf(letter)] === g.letters[currentIndex]) {
                doubleSwappers.push([letter, g.letters[currentIndex]]);
            } else {
                singleSwappers.push([letter, g.letters[currentIndex]]);
            }
        }
    });
    if (doubleSwappers.length) {
        swapPair = doubleSwappers[randInt(doubleSwappers.length)];
    } else if (singleSwappers.length) {
        swapPair = singleSwappers[randInt(singleSwappers.length)];
    }
    if (!swapPair) {
        return;
    }
    if (g.sound) {
   		playAudio(g.sounds.CLICK);
    }
    console.log("swapping " + swapPair[0] + " with " + swapPair[1]);
    g.currentText = swapLetters(g.currentText, swapPair[0], swapPair[1], false, true);
    $('#letterBox .letterButtons .letterButton:nth(' + g.letters.indexOf(swapPair[1]) + ')')
        .addClass('locked')
        .draggable('disable')
        .droppable('disable');
    g.swapHistory = _.filter(g.swapHistory, function (one) { if (one.indexOf(swapPair[1]) !== -1) return false; return true; });
    fillQuoteBox(g.currentText);
    displayMovedButtons();
    updateFrequencies();
    g.hintsAvailable--;
    g.hintsUsed++;
    if (g.originalText === getStrippedCurrentText()) {
    	win();
    }
    $('#hintsAvailable').text(g.hintsAvailable);
    checkpoint();
}

function newGame() {
    clearIdle();
	g.originalText = g.currentText = g.niceSolution = null;
	g.currentOrder = g.letters.slice();
	g.solutionOrder = g.letters.slice();
	$('.letterButtons .letterButton.locked')
	    .removeClass('locked')
	    .draggable('enable')
	    .droppable('enable');
    g.swapHistory = [];
    g.secondsUsed = 0;
    g.hintsUsed = 0;
	checkpoint();
	hidePopup();
    $('#quoteContainer').removeClass('won');
    $('#letterBox').show();
    $('#playAgain').hide();
    g.clock.setTime(0);
    $('#quoteBox')[0].scrollTop = 0;

	g.instructionsShown = true;
	gotText(g.fullText, false);
	whenAd(showAd);
}

function donateButton() {
    var url = "http://igg.me/at/beace/x/10620297";
    clearIdle();
    if (inBrowser()) {
        window.open(url, "_blank");
    } else {
        if (isAndroid) {
            navigator.app.loadUrl(url, { openExternal: true });
        } else {
            window.open(url, '_system');
        }
    }
}

function resetTutorial() {
    $(".tutorialPuzzleDiv").each(function () {
        $(this).text($(this).data('original'));
    });
}

function showTutorial(i) {
    showPopup('tutorial' + i);
}
function backToMenu(e) {
    showPopup('menu');
    e.stopPropagation();
}

function rateButton () {
    if (isIOS) {
        window.open("http://itunes.apple.com/WebObjects/MZStore.woa/wa/viewContentsUserReviews?id=978460786&pageNumber=0&sortOrdering=2&type=Purple+Software&mt=8");
    } else {
        window.open("market://details?id=com.beacegames.biblefree");
    }
}

function movedToBackground () {
    stopClock(true);
}
function returnedFromBackground () {
    startClock(true);
}
function init() {
	document.addEventListener("pause", movedToBackground, false);
	document.addEventListener("resume", returnedFromBackground, false);
    $("#letterBox .letterButton").mousedown(function(e) {
        indicateDrag(this, true);
        showDragFeedback($(this).text(), true);
    }).mouseup(function(e) {
        indicateDrag(this, false);
        showDragFeedback("", false);
        $('.letterButton.hovered').removeClass('hovered');
	}).draggable({
		cancel:false,
		containment: '#letterBox',
	    start: function (e) {
                    //indicateDrag(e, true);
		},
	    stop: function () {
                    //indicateDrag(this, false);
		},
		revert: function () {
			if (g.moveButtons) {
				if ($(this).data("wasMoved")) {
					$(this).addClass("moved");
				}
				$(this).data("uiDraggable").originalPosition.top = 0;
			}
			$('.letterButton.hovered').removeClass('hovered');
			return true;
		},
		zIndex: 999
	}).droppable({
        hoverClass: 'hovered',
        tolerance: 'intersect',
		out: function (event, ui) {
			if (g.sound) {
				playAudio(g.sounds.CLACK);
			}
		    displayDragFeedback(ui.helper.text(), null);
        },
		over: function (event, ui) {
			if (g.sound) {
				playAudio(g.sounds.CLICK);
			}
		    displayDragFeedback(ui.helper.text(), $(event.target).text());
		},
		drop: function(event, ui) {
			var target, draggedOne, temp;
			if (!g.currentText) {
				return;
			}
			if (g.sound) {
				playAudio(g.sounds.SWAP);
			}
			target = $(event.target);
			draggedOne = ui.helper;
			g.currentText = swapLetters(g.currentText, target.text(), draggedOne.text(), true);
			fillQuoteBox(g.currentText);
			if (g.moveButtons) {
				draggedOne.removeClass("moved");
				target.removeClass("moved");
				temp = target.text();
				target.text(draggedOne.text());
				if (g.currentOrder.indexOf(draggedOne.text()) === g.letters.indexOf(draggedOne.text())) {
					target.removeClass("moved");
					target.data("wasMoved", false);
				} else {
					target.addClass("moved");
					target.data("wasMoved", true);
				}
				draggedOne.text(temp);
				if (g.currentOrder.indexOf(draggedOne.text()) === g.letters.indexOf(draggedOne.text())) {
					draggedOne.removeClass("moved");
					draggedOne.data("wasMoved", false);
				} else {
					draggedOne.addClass("moved");
					draggedOne.data("wasMoved", true);
				}
			}
			updateFrequencies();
						checkpoint();
			if (g.originalText === getStrippedCurrentText()) {
				win();
			}
			setTimeout(function() {
			    $('.letterButton.hovered').removeClass('hovered');
			}, 1);
		}
	});
	$(".tutorial .letterButton").mousedown(function(e) {
        indicateDrag(this, false);
        showDragFeedback($(this).text(), true);
    }).mouseup(function(e) {
        indicateDrag(this, false);
        showDragFeedback("", false);
        $('.letterButton.hovered').removeClass('hovered');
    }).draggable({
    	cancel:false,
    	revert: function () {
    		if (g.moveButtons) {
    			if ($(this).data("wasMoved")) {
    				$(this).addClass("moved");
    			}
    			$(this).data("uiDraggable").originalPosition.top = 0;
    		}
    		$('.letterButton.hovered').removeClass('hovered');
    		return true;
    	},
    	zIndex: 999
    }).droppable({
        hoverClass: 'hovered',
        tolerance: 'intersect',
    	out: function (event, ui) {
    	    if (g.sound) {
    			playAudio(g.sounds.CLACK);
    		}
    	    displayDragFeedback(ui.helper.text(), null);
        },
    	over: function (event, ui) {
    		if (g.sound) {
    			playAudio(g.sounds.CLICK);
    		}
    	    displayDragFeedback(ui.helper.text(), $(event.target).text());
    	},
    	drop: function(event, ui) {
    		var target, draggedOne, temp, letterOne, letterTwo, table, tutorialLevel, currentText;
    		if (!g.currentText) {
    			return;
    		}
    		if (g.sound) {
    			playAudio(g.sounds.SWAP);
    		}
    		target = $(event.target);
    		draggedOne = ui.helper;
    		letterOne = target.text();
    		letterTwo = draggedOne.text();
    		table = target.closest('table');
    		tutorialLevel = table.data('tutorial');
    		switch (tutorialLevel) {
    		case 1:
    		    showPopup('tutorial2');
    		    return;
    		case 2:
    		    $('#tutorialPuzzleDiv2').text('AND GOD SAID LET THERE BE LIGHT');
    		    setTimeout(function () {
    		        showPopup('tutorial3');
    		    }, 1000);
    		    return;
    		case 3:
    		    currentText = $('#tutorialPuzzleDiv3').text();
    		    currentText = tutorialSwap(currentText, letterOne, letterTwo);
    		    $('#tutorialPuzzleDiv3').text(currentText);
    		    if (currentText.trim() === 'IN THE BEGINNING GOD CREATED THE HEAVEN AND THE EARTH') {
    		        setTimeout(function () {
    		            showPopup('tutorial4');
    		        }, 1000);
    		    }
    		    return;
    		}
    		//fillQuoteBox(g.currentText);
    		if (g.moveButtons) {
    			draggedOne.removeClass("moved");
    			target.removeClass("moved");
    			temp = target.text();
    			target.text(draggedOne.text());
    			if (g.currentOrder.indexOf(draggedOne.text()) === g.letters.indexOf(draggedOne.text())) {
    				target.removeClass("moved");
    				target.data("wasMoved", false);
    			} else {
    				target.addClass("moved");
    				target.data("wasMoved", true);
    			}
    			draggedOne.text(temp);
    			if (g.currentOrder.indexOf(draggedOne.text()) === g.letters.indexOf(draggedOne.text())) {
    				draggedOne.removeClass("moved");
    				draggedOne.data("wasMoved", false);
    			} else {
    				draggedOne.addClass("moved");
    				draggedOne.data("wasMoved", true);
    			}
    		}
    		setTimeout(function() {
    		    $('.letterButton.hovered').removeClass('hovered');
    		}, 1);
    	}
    });
	$("#menuButton, #pipeButton").click(function () {showPopup('menu'); return false;});
	$("#instructionsButton").click(function () {showPopup('instructions'); return false;});
	$("#tutorialButton").click(function () {resetTutorial(); showPopup('tutorial1'); return false;});
	$("#aboutButton").click(function () {showPopup('about'); return false;});
	$("#rateButton").click(rateButton);
	$("#popupWrapper").click(function () { if (!$('.tutorialDiv:visible').length) hidePopup(); return false;});
	$("#difficultyButton").click(showDifficultyMenu);
	$("#difficultyMenu button").click(changeDifficulty);
	$("#moveButtons").click(function () {showPopup('moveButtonsMenu'); return false;});
	$("#moveButtonsMenu button").click(changeMoveButtons);
	$("#frequencyButton").click(function () {showPopup('frequencyMenu'); return false;});
	$("#frequencyMenu button").click(changeFrequency);
	$("#soundButton").click(function () {showPopup('soundMenu'); return false;});
	$("#sourceButton").click(function () {showPopup('sourceMenu'); return false;});
	$("#sourceMenu button").click(changeSource);
	$("#soundMenu button").click(changeSound);
	/* there are two store buttons */
	$(".storeButton").click(function () {showPopup('storeMenu'); return false;});
	$('#optionsButton').click(function () {showPopup('optionsMenu'); return false;});
	$("#purchaseButton").click(purchaseFullVersion);
	$("#restoreButton").click(restorePurchases);
	$("#purchasePakButton").click(purchasePakButton);
	$("#purchaseBigPakButton").click(purchaseBigPakButton);
	$('#donateButton').click(donateButton);
	$('#showLeaderboardButton').click(showLeaderboard);
	$('#quoteBox').click(clearIdle);
	$('.idleIndicator').click(clearIdle);
	$(".expectedFrequency").each(function (i) {
		$(this).text(g.expectedFrequencies[i].toFixed(1));
	});
	$("#difficultyPlaque").click(showDifficultyMenu);
	g.gauge = new JustGage({id: "progressGauge",
		value: 0,
		showMinMax: false,
		min: 0,
		max: 100,
		title: "Progress",
		levelColors : ["#ff0000", "#f9c802", "#a9d70b"],
		levelColorsGradient: true
	});

	$("#progressGauge").click(function () {
   	    if (!$("#difficultyPlaque:visible").length) {
   	        showDifficultyMenu();
   	    }
  	});


	$("#undoButton").click(undoSwap);
	$('#hintButton').click(getHint);
	$("#muteButton").click(toggleSound);
	//g.clock = $("#clock").FlipClock({autoStart: false});
	g.clock = new SimpleClock('#simpleClock');
	$("#newGameButton, #playAgain").click(newGame);
	//$('#simpleClock').click(function (event) {
	//	if (!g.clockStopped) {
	//		stopClock();
	//	}
	//	return false;
	//});

	if (!getUrlParameter('alreadyShown') && !g.instructionsShown) {
	    g.instructionsShown = true;
	    checkpoint();
	    showPopup('tutorial1');
	}
	setTimeout(function () {
		$('.idleIndicator').show();
	}, g.MAX_IDLE_SECS * 1000);
}

function clearIdle() {
    $('.idleIndicator').hide();
}

function showDragFeedback(item, state) {
    if (state) {
        $("#dragged").text(item);
        $(document.body).addClass('showDragFeedback');
    } else {
        $("#dragged").text("");
        $("#target").text("");
        $(document.body).removeClass('showDragFeedback');
        $('.letterButton.hovered').removeClass('hovered');
    }
}

function displayDragFeedback(item, target) {
    $("#dragged").text(item);
    $("#target").text(target || ' ');
}

$(document).ready(function() {
    if (inBrowser()) {
        onDeviceReady();
    }
    document.addEventListener('deviceready', function() {
        onDeviceReady();
    });
});
